# Opinionated task running in Google Cloud

This module provides an opinionated deployment of asynchronous tasks making use of the
[ucam-faas](https://pypi.org/project/ucam-faas/) Python library.

<!-- BEGIN_TF_DOCS -->
## Requirements

| Name | Version |
|------|---------|
| <a name="requirement_terraform"></a> [terraform](#requirement\_terraform) | ~> 1.3 |
| <a name="requirement_google"></a> [google](#requirement\_google) | >= 4.0 |
| <a name="requirement_google-beta"></a> [google-beta](#requirement\_google-beta) | >= 4.0 |
| <a name="requirement_null"></a> [null](#requirement\_null) | ~> 3.0 |

## Inputs

| Name | Description | Type | Default | Required |
|------|-------------|------|---------|:--------:|
| <a name="input_alerting"></a> [alerting](#input\_alerting) | monitoring\_scoping\_project - The ID of a Cloud Monitoring scoping project to create monitoring resources in.<br/>    notification\_channels - A list of notification channel IDs to send uptime alerts to. The format for<br/>      the channel IDs should be "projects/[PROJECT\_ID]/notificationChannels/[CHANNEL\_ID]".<br/><br/>    alerts -<br/>      failed\_after\_retries - Will alert if any events aren't processed successfully even after retries<br/>      dead\_letter\_message\_expiring - Will alert if one or more messages in dead letter queue will<br/>        expire within 3 days. Disabled if dead letter messages are not persisted (e.g. cron jobs). | <pre>object({<br/>    monitoring_scoping_project = string<br/>    notification_channels      = list(string)<br/>    alerts = optional(object({<br/>      failed_after_retries         = optional(bool, true)<br/>      dead_letter_message_expiring = optional(bool)<br/>    }), {})<br/>  })</pre> | n/a | yes |
| <a name="input_concurrency"></a> [concurrency](#input\_concurrency) | Options that determine concurrency of the function.<br/><br/>  max\_concurrent\_functions - default 80 - total concurrent instances of the function across all containers.<br/>  Must be an increment of max\_container\_concurrency (or less than in which case max\_container\_concurrency is ignored)<br/><br/>  max\_container\_concurrency - default 8 - maximum concurrent functions per container. | <pre>object({<br/>    max_concurrent_functions  = optional(number, 80)<br/>    max_container_concurrency = optional(number, 8)<br/>  })</pre> | `{}` | no |
| <a name="input_dead_letter"></a> [dead\_letter](#input\_dead\_letter) | Whilst pub/sub deadletter queues are always created per subscription, the messages are not<br/>     always retained and sometimes just used to control retries and help alerting.<br/><br/>     When a topic is provided as a trigger the dead letter queue will retain<br/>     messages for 14 days unless message\_retention\_duration is set to override.<br/><br/>     For cron jobs, the default is to not to retain messages unless message\_retention\_duration\_seconds<br/>     is set. With no retention policy or subscribers events/messages are lost after retries fail.<br/>     See https://registry.terraform.io/providers/hashicorp/google/latest/docs/resources/pubsub_topic#message_retention_duration<br/>     for valid values. | <pre>object({<br/>    message_retention_duration_seconds = optional(number)<br/><br/>  })</pre> | `{}` | no |
| <a name="input_deletion_protection"></a> [deletion\_protection](#input\_deletion\_protection) | Optional. Whether Terraform will be prevented from destroying<br/>the Cloud Run resource. Defaults to false. | `bool` | `false` | no |
| <a name="input_enable_pre_deploy_job"></a> [enable\_pre\_deploy\_job](#input\_enable\_pre\_deploy\_job) | Configure a Cloud Run Job to be executed *before* the main Cloud Run service<br/>is deployed. This is useful for running database migrations for example. | `bool` | `false` | no |
| <a name="input_enable_static_egress_ip"></a> [enable\_static\_egress\_ip](#input\_enable\_static\_egress\_ip) | Whether to assign a static ip for egress from this cloud run instance. If<br/>enabled, the "vpcaccess.googleapis.com" API must also be enabled on the<br/>project. | `bool` | `false` | no |
| <a name="input_function"></a> [function](#input\_function) | container\_image - The container image with the function.<br/>    cmd - Override default function to call. Useful when a container has multiple functions.<br/>    env - Pass in environment variables to function container. Uses same for as cloud run but<br/>      should be list.<br/>    cpu\_limit - Maximum CPU limit a function may received. Generally this is the upper limit<br/>      and functions may share this within a single container based on Cloud Run scheduling and<br/>      settings in concurrency.<br/>    memory\_limit - Maximum memory limit a function may received. Generally this is the upper limit<br/>      and functions may share this within a single container based on Cloud Run scheduling and<br/>      settings in concurrency. | <pre>object({<br/>    container_image = string<br/>    cmd             = optional(string, null)<br/>    env = optional(list(object({<br/>      name  = string<br/>      value = optional(string)<br/>      value_source = optional(object({<br/>        secret_key_ref = optional(object({<br/>          secret  = string<br/>          version = optional(string, "latest")<br/>        }))<br/>      }))<br/>    })), [])<br/>    cpu_limit    = optional(number, 1) # null doesn't play well with the state<br/>    memory_limit = optional(string, "512Mi")<br/>  })</pre> | n/a | yes |
| <a name="input_grant_sql_client_role_to_cloud_run_sa"></a> [grant\_sql\_client\_role\_to\_cloud\_run\_sa](#input\_grant\_sql\_client\_role\_to\_cloud\_run\_sa) | When set to true the roles/cloudsql.client role will be granted to the cloud<br/>run service account at the project level to allow it to connect to Cloud SQL. | `bool` | `false` | no |
| <a name="input_location"></a> [location](#input\_location) | The location where the service will be deployed. | `string` | `"europe-west2"` | no |
| <a name="input_min_ports_per_vm"></a> [min\_ports\_per\_vm](#input\_min\_ports\_per\_vm) | When using Cloud NAT to provide an egress route, Cloud NAT's minimum ports per<br/>VM can be configured to determine how many concurrent connections can be<br/>established to the same destination IP address and port. | `number` | `64` | no |
| <a name="input_mount_cloudsql_instance"></a> [mount\_cloudsql\_instance](#input\_mount\_cloudsql\_instance) | Mount a single CloudSQL instance into the FaaS service container. This value<br/>should be the Cloud SQL instance connection name, for example<br/>"example-devel-e662dd2b:europe-west2:sql-6e1dd60b". | `string` | `null` | no |
| <a name="input_name"></a> [name](#input\_name) | The name of the Cloud Run service. | `string` | n/a | yes |
| <a name="input_pre_deploy_job_annotations"></a> [pre\_deploy\_job\_annotations](#input\_pre\_deploy\_job\_annotations) | Map of key/value pairs containing annotations to assign to the pre-deploy Cloud<br/>Run job. | `map(string)` | `null` | no |
| <a name="input_pre_deploy_job_container"></a> [pre\_deploy\_job\_container](#input\_pre\_deploy\_job\_container) | Configure the container instance for the pre-deploy job. See<br/>https://registry.terraform.io/providers/hashicorp/google/latest/docs/resources/cloud_run_v2_job#nested_containers<br/>for more information on these options. | <pre>object({<br/>    name    = optional(string)<br/>    image   = optional(string)<br/>    command = optional(list(string))<br/>    args    = optional(list(string))<br/>    env = optional(list(object({<br/>      name  = string<br/>      value = optional(string)<br/>      value_source = optional(object({<br/>        secret_key_ref = optional(object({<br/>          secret  = string<br/>          version = optional(string, "latest")<br/>        }))<br/>      }))<br/>    })), [])<br/>    resources = optional(object({<br/>      limits = optional(map(string))<br/>    }))<br/>    ports = optional(list(object({<br/>      name           = optional(string)<br/>      container_port = optional(number)<br/>    })), [])<br/>    volume_mounts = optional(list(object({<br/>      name       = string<br/>      mount_path = string<br/>    })), [])<br/>    working_dir = optional(string)<br/>  })</pre> | `null` | no |
| <a name="input_pre_deploy_job_encryption_key"></a> [pre\_deploy\_job\_encryption\_key](#input\_pre\_deploy\_job\_encryption\_key) | The ID of a customer managed encryption key (CMEK) to use to encrypt this<br/>container image. | `string` | `null` | no |
| <a name="input_pre_deploy_job_execution_environment"></a> [pre\_deploy\_job\_execution\_environment](#input\_pre\_deploy\_job\_execution\_environment) | The execution environment to host this task. Possible values are<br/>EXECUTION\_ENVIRONMENT\_GEN1, and EXECUTION\_ENVIRONMENT\_GEN2 | `string` | `"EXECUTION_ENVIRONMENT_GEN2"` | no |
| <a name="input_pre_deploy_job_force"></a> [pre\_deploy\_job\_force](#input\_pre\_deploy\_job\_force) | When true, and only when used in addition to var.pre\_deploy\_job\_trigger, the<br/>pre-deploy Cloud Run job is executed at every terraform apply, regardless of<br/># the status of var.pre\_deploy\_job\_container.image. | `bool` | `false` | no |
| <a name="input_pre_deploy_job_labels"></a> [pre\_deploy\_job\_labels](#input\_pre\_deploy\_job\_labels) | Map of key/value pairs containing labels to assign to the pre-deploy Cloud Run<br/>job. | `map(string)` | `null` | no |
| <a name="input_pre_deploy_job_launch_stage"></a> [pre\_deploy\_job\_launch\_stage](#input\_pre\_deploy\_job\_launch\_stage) | The launch stage for the pre-deploy Cloud Run job. Possible values are UNIMPLEMENTED,<br/>PRELAUNCH, EARLY\_ACCESS, ALPHA, BETA, GA, and DEPRECATED. | `string` | `"GA"` | no |
| <a name="input_pre_deploy_job_max_retries"></a> [pre\_deploy\_job\_max\_retries](#input\_pre\_deploy\_job\_max\_retries) | Configure the maximum number of retries for the pre-deploy job. | `number` | `null` | no |
| <a name="input_pre_deploy_job_mount_cloudsql_instance"></a> [pre\_deploy\_job\_mount\_cloudsql\_instance](#input\_pre\_deploy\_job\_mount\_cloudsql\_instance) | Mount a CloudSQL instance in the pre-deploy job container. This is a<br/>convenience variable to simplify mounting a Cloud SQL instance. However, if<br/>you require more control over this you should define it directly in<br/>var.pre\_deploy\_job\_container instead. | `string` | `null` | no |
| <a name="input_pre_deploy_job_parallelism"></a> [pre\_deploy\_job\_parallelism](#input\_pre\_deploy\_job\_parallelism) | Specifies the maximum desired number of tasks the execution should run at<br/>given time. | `number` | `null` | no |
| <a name="input_pre_deploy_job_task_count"></a> [pre\_deploy\_job\_task\_count](#input\_pre\_deploy\_job\_task\_count) | Specifies the desired number of tasks the execution should run. | `number` | `null` | no |
| <a name="input_pre_deploy_job_timeout"></a> [pre\_deploy\_job\_timeout](#input\_pre\_deploy\_job\_timeout) | Configure a timeout, in seconds, for the pre-deploy job. | `string` | `null` | no |
| <a name="input_pre_deploy_job_trigger"></a> [pre\_deploy\_job\_trigger](#input\_pre\_deploy\_job\_trigger) | When true, the pre-deploy Cloud Run job is executed via a<br/>null\_resource-triggered gcloud command whenever Terraform detects that<br/>var.pre\_deploy\_job\_container.image has changed. | `bool` | `true` | no |
| <a name="input_pre_deploy_job_volumes"></a> [pre\_deploy\_job\_volumes](#input\_pre\_deploy\_job\_volumes) | Configure one or more volumes for the pre-deploy job. See<br/>https://registry.terraform.io/providers/hashicorp/google/latest/docs/resources/cloud_run_v2_job#nested_volumes<br/>for more information on these options. | <pre>list(object({<br/>    name = string<br/>    secret = optional(object({<br/>      secret       = string<br/>      default_mode = optional(number)<br/>      items = optional(list(object({<br/>        path    = string<br/>        version = optional(string)<br/>        mode    = optional(number)<br/>      })), [])<br/>    }))<br/>    cloud_sql_instance = optional(object({<br/>      instances = optional(list(string))<br/>    }))<br/>  }))</pre> | `[]` | no |
| <a name="input_pre_deploy_job_vpc_access"></a> [pre\_deploy\_job\_vpc\_access](#input\_pre\_deploy\_job\_vpc\_access) | Configure VPC access for the pre-deploy job. See<br/>https://registry.terraform.io/providers/hashicorp/google/latest/docs/resources/cloud_run_v2_job#nested_vpc_access<br/>for more information on these options. | <pre>object({<br/>    connector = optional(string)<br/>    egress    = optional(string)<br/>    network_interfaces = optional(object({<br/>      network    = optional(string)<br/>      subnetwork = optional(string)<br/>      tags       = optional(string)<br/>    }))<br/>  })</pre> | `null` | no |
| <a name="input_project"></a> [project](#input\_project) | The ID of the project where the resources will be deployed. | `string` | n/a | yes |
| <a name="input_retry_count"></a> [retry\_count](#input\_retry\_count) | Number of attempts to retry a job. | `number` | `4` | no |
| <a name="input_static_egress_ip_cidr_range"></a> [static\_egress\_ip\_cidr\_range](#input\_static\_egress\_ip\_cidr\_range) | The cidr range used to create a subnet that this cloud run will use if assigned<br/>a static ip | `string` | `"10.124.0.0/28"` | no |
| <a name="input_static_egress_ip_subnetwork_id"></a> [static\_egress\_ip\_subnetwork\_id](#input\_static\_egress\_ip\_subnetwork\_id) | When using an existing VPC Access Connector with the static egress IP<br/>configuration an existing subnetwork must be provided. | `string` | `null` | no |
| <a name="input_timeout_seconds"></a> [timeout\_seconds](#input\_timeout\_seconds) | Maximum duration of the function before it timeouts and marked as failed. | `number` | n/a | yes |
| <a name="input_triggers"></a> [triggers](#input\_triggers) | pubsub\_topic\_id - PUB/SUB topic ID to subscribe to and trigger function from.<br/>  cron\_schedules - list of crontab style scheduler strings, e.g. ["30 16 * * 7"]<br/>  See http://man7.org/linux/man-pages/man5/crontab.5.html | <pre>object({<br/><br/>    pubsub_topic_id = optional(string, null)<br/>    cron_schedules  = optional(list(string), [])<br/><br/>  })</pre> | n/a | yes |
| <a name="input_vpc_access"></a> [vpc\_access](#input\_vpc\_access) | Configure VPC access for the Cloud Run service. For more information on these<br/>options see<br/>https://registry.terraform.io/providers/hashicorp/google/latest/docs/resources/cloud_run_v2_service#nested_vpc_access | <pre>object({<br/>    connector = optional(string)<br/>    egress    = optional(string)<br/>    network_interfaces = optional(object({<br/>      network    = optional(string)<br/>      subnetwork = optional(string)<br/>      tags       = optional(string)<br/>    }))<br/>  })</pre> | `null` | no |
| <a name="input_vpc_access_connector_max_throughput"></a> [vpc\_access\_connector\_max\_throughput](#input\_vpc\_access\_connector\_max\_throughput) | Optional. The maximum throughput of the connector in megabytes per second.<br/>Defaults to 300. | `number` | `300` | no |
| <a name="input_vpc_access_connector_min_throughput"></a> [vpc\_access\_connector\_min\_throughput](#input\_vpc\_access\_connector\_min\_throughput) | Optional. The minimum throughput of the connector in megabytes per second.<br/>Defaults to 200. | `number` | `200` | no |

## Outputs

| Name | Description |
|------|-------------|
| <a name="output_dead_letter_topic_id"></a> [dead\_letter\_topic\_id](#output\_dead\_letter\_topic\_id) | PUB/SUB dead letter topic for trigger/subscription. |
| <a name="output_service"></a> [service](#output\_service) | Webapp Cloud Run service resource |
| <a name="output_service_account"></a> [service\_account](#output\_service\_account) | Service account which service runs as |
<!-- END_TF_DOCS -->
